//+------------------------------------------------------------------+
//|                                                      BO-PANEL.mq4 |
//|                                                       Pit|
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Pit"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
// Lets include the imports file mt4gui.mqh
#include <mt4gui2.mqh>

// global Variable
int hwnd, Panel, PutBtn, CallBtn, TM, Amount, Num, FileHandle;
string FileName = "BO-PANEL"+Symbol()+".txt";
string Timelimit;
string Price = "0.01";
string Number = "M1";
double Investment;
int BarOn;
bool AllowAlert;
int OkAlert;
extern int MagicNumber = 2505; 
extern int MovingPeriod  = 12;
extern int MovingShift = 6;
extern double MACDOpenLevel = 3;
extern int MATrendPeriod = 26;
extern bool EnableSoundAlert = TRUE;

int OnInit(){
string to_split=ReadData();
string sep="|";
ushort u_sep;   
string result[];  
//--- Get the separator code
u_sep=StringGetCharacter(sep,0);
//--- Split the string to substrings
int k=StringSplit(to_split,u_sep,result);
//--- Now output all obtained strings
if(k>0){
for(int i=0;i<k;i++){
Price = result[0];
Number = result[1];
}
if (Price == ""){
Price = "0.01";
}
if (Number == ""){
Num = 0;
}
if (Number == "M1") Num= 0;
if (Number == "M2") Num= 1;
if (Number == "M5") Num= 2;
if (Number == "M10") Num= 3;
if (Number == "M15") Num= 4;
if (Number == "M30") Num= 5;
if (Number == "H1") Num= 6;
}
hwnd = WindowHandle(Symbol(),Period());    
// In case there have GUI Items on chart, lets remove them all
guiRemoveAll(hwnd); 
// Every GUI Item returns a handle
   // List Object   
Panel= guiAdd(hwnd,"label",5,20,327,40,"");   
guiSetBgColor(hwnd,Panel,Black);        
TM = guiAdd(hwnd,"list",12,27,60,30,"TM"); 
guiAddListItem(hwnd,TM,"M1");
guiAddListItem(hwnd,TM,"M2");
guiAddListItem(hwnd,TM,"M5");
guiAddListItem(hwnd,TM,"M10");
guiAddListItem(hwnd,TM,"M15");
guiAddListItem(hwnd,TM,"M30");
guiAddListItem(hwnd,TM,"H1");
guiSetListSel(hwnd,TM,Num); 
CallBtn = guiAdd(hwnd,"button",75,25,100,30,"CALL");
guiSetBorderColor(hwnd,CallBtn,Black);
guiSetBgColor(hwnd,CallBtn,Lime);
PutBtn = guiAdd(hwnd,"button",175,25,100,30,"PUT");
guiSetBorderColor(hwnd,PutBtn,Black);
guiSetBgColor(hwnd,PutBtn,Red);
Amount = guiAdd(hwnd,"text",277,30,50,20,Price);   
guiSetBgColor(hwnd,Amount,White);
guiSetTextColor(hwnd,Amount,Black);    
return(0);
}
  
int deinit(){
// Very important to cleanup and remove all gui items from chart
if (hwnd>0) { guiRemoveAll(hwnd);    guiCleanup(hwnd);}
return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void OnTick(){
// Button GUI Item has Clicked Event to capture
// You can use "guiIsClicked" command to capture the event
if (guiIsClicked(hwnd,CallBtn)){
Investment = StringToDouble(guiGetText(hwnd,Amount));
Timelimit = CTime(guiGetText(hwnd,TM));
int ticket=-1;
ticket=OrderSend(Symbol(),OP_BUY,Investment,0,0,0,0,"BO exp:"+Timelimit,MagicNumber,0,clrNONE); 
if(ticket<0){
Print("OrderSend call failed with error #",GetLastError());
}else{
Print("OrderSend placed call successfully");
WriteData(guiGetText(hwnd,Amount)+"|"+guiGetText(hwnd,TM));
}
}

if (guiIsClicked(hwnd,PutBtn)){
Investment = StringToDouble(guiGetText(hwnd,Amount));
Timelimit = CTime(guiGetText(hwnd,TM));
int ticket=-1;
ticket=OrderSend(Symbol(),OP_SELL,Investment,0,0,0,0,"BO exp:"+Timelimit,MagicNumber,0,clrNONE); 
if(ticket<0){
Print("OrderSend put failed with error #",GetLastError());
}else{
Print("OrderSend placed put successfully");
WriteData(guiGetText(hwnd,Amount)+"|"+guiGetText(hwnd,TM));
}
}

for (int x = OrdersTotal() - 1; x >= 0; x--) {
double res=OrderSelect(x, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol() == Symbol() && OrderType() == OP_BUY) {
return;
}
if (OrderSymbol() == Symbol() && OrderType() == OP_SELL) {
return;
}
}

AllowAlert = CheckAlert();
if (AllowAlert) OkAlert = 0;

//--- get Moving Average 
double ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
if(Open[1]<ma && Close[1]>ma && OkAlert == 0){
if (EnableSoundAlert) {
OkAlert = 1;
Alert(TimeToStr(Time[0], TIME_DATE|TIME_MINUTES) + " MA CALL " + Symbol() + " " + f0_0(Period()));
}
MakeArrow("CALL");
}

if(Open[1]>ma && Close[1]<ma && OkAlert == 0){
if (EnableSoundAlert) {
OkAlert = 1;
Alert(TimeToStr(Time[0], TIME_DATE|TIME_MINUTES) + " MA PUT " + Symbol() + " " + f0_0(Period()));
}
MakeArrow("PUT");
}

double MacdCurrent,MacdPrevious;
double SignalCurrent,SignalPrevious;
double MaCurrent,MaPrevious;
//--- to simplify the coding and speed up access data are put into internal variables
MacdCurrent=iMACD(NULL,0,24,52,9,PRICE_CLOSE,MODE_MAIN,0);
MacdPrevious=iMACD(NULL,0,24,52,9,PRICE_CLOSE,MODE_MAIN,1);
SignalCurrent=iMACD(NULL,0,24,52,9,PRICE_CLOSE,MODE_SIGNAL,0);
SignalPrevious=iMACD(NULL,0,24,52,9,PRICE_CLOSE,MODE_SIGNAL,1);
MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);

if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious && 
MathAbs(MacdCurrent)>(MACDOpenLevel*Point) && MaCurrent>MaPrevious && OkAlert == 0){
if (EnableSoundAlert) {
OkAlert = 1;
Alert(TimeToStr(Time[0], TIME_DATE|TIME_MINUTES) + " MACD CALL " + Symbol() + " " + f0_0(Period()));
}
MakeArrow("CALL");
}

if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious && 
MacdCurrent>(MACDOpenLevel*Point) && MaCurrent<MaPrevious && OkAlert == 0){
if (EnableSoundAlert) {
OkAlert = 1;
Alert(TimeToStr(Time[0], TIME_DATE|TIME_MINUTES) + " MACD PUT " + Symbol() + " " + f0_0(Period()));
}
MakeArrow("PUT");
}
}

void MakeArrow(string arrowname){
string name="Arrow"+TimeToStr(Time[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS); 
if (arrowname == "CALL"){
ObjectCreate(name,OBJ_ARROW,0,Time[0],Low[0]-15*Point);  
ObjectSet(name,OBJPROP_PRICE,Low[0]-5*Point);  
ObjectSet(name,OBJPROP_ARROWCODE,108); 
ObjectSet(name, OBJPROP_COLOR,Lime);
}
if (arrowname == "PUT"){
ObjectCreate(name,OBJ_ARROW,0,Time[0],High[0]+15*Point); 
ObjectSet(name,OBJPROP_PRICE,High[0]+5*Point);  
ObjectSet(name,OBJPROP_ARROWCODE,108); 
ObjectSet(name, OBJPROP_COLOR,Red);
}
}


string CTime(string t){
if (t == "M1") t= "60";
if (t == "M2") t= "120";
if (t == "M5") t= "300";
if (t == "M10") t= "600";
if (t == "M15") t= "900";
if (t == "M30") t= "1800";
if (t == "H1") t= "3600";
return t;
}

int CheckAlert() {
bool AlertAllowed = FALSE;
if (BarOn != Bars) {
AlertAllowed = TRUE;
BarOn = Bars;
}
return (AlertAllowed);
}

string f0_0(int Ai_0) {
if (Ai_0 == 1) return ("M1");
if (Ai_0 == 5) return ("M5");
if (Ai_0 == 15) return ("M15");
if (Ai_0 == 30) return ("M30");
if (Ai_0 == 60) return ("H1");
if (Ai_0 == 240) return ("H4");
if (Ai_0 == 1440) return ("D1");
if (Ai_0 == 10080) return ("W1");
if (Ai_0 == 43200) return ("MN1");
return ("");
}

string ReadData(){
string str;
FileHandle = FileOpen(FileName,FILE_TXT|FILE_READ | FILE_WRITE);
str=FileReadString(FileHandle,0);
FileClose(FileHandle);
return str;
}

string WriteData(string data){
FileHandle = FileOpen(FileName,FILE_TXT|FILE_READ | FILE_WRITE);
FileSeek(FileHandle, 0, 0);
FileWrite(FileHandle,data);
FileClose(FileHandle);
return data;
}
//+------------------------------------------------------------------+
